From 76d44c31bf8ba88ca4f9bbc3aa9c457b99f7310b Mon Sep 17 00:00:00 2001
From: Ajin Cherian <itsajin@gmail.com>
Date: Thu, 12 Sep 2024 02:29:24 -0400
Subject: [PATCH v13 1/5] Add CONFLICT RESOLVERS into the syntax for CREATE and
 ALTER SUBSCRIPTION

This patch provides support for configuring subscriptions with conflict resolvers

Syntax for CREATE SUBSCRIPTION:
CREATE SUBSCRIPTION <subname> CONNECTION <conninfo> PUBLICATION <pubname> CONFLICT RESOLVER
    (conflict_type1 = resolver1, conflict_type2 = resolver2, conflict_type3 = resolver3,...);

Syntax for ALTER SUBSCRIPTION:
ALTER SUBSCRIPTION <subname> CONFLICT RESOLVER
    (conflict_type1 = resolver1, conflict_type2 = resolver2, conflict_type3 = resolver3,...);

Syntax for reseting conflict resolvers:
 ALTER SUBSCRIPTION <subname> RESET CONFLICT RESOLVER ALL

 ALTER SUBSCRIPTION <subname> RESET CONFLICT RESOLVER FOR conflict_type

Additionally, this patch includes documentation for conflict resolvers.
---
 doc/src/sgml/logical-replication.sgml          |  88 +-----
 doc/src/sgml/monitoring.sgml                   |  13 +-
 doc/src/sgml/ref/alter_subscription.sgml       |  12 +
 doc/src/sgml/ref/create_subscription.sgml      | 178 +++++++++++
 src/backend/commands/subscriptioncmds.c        |  98 ++++++
 src/backend/parser/gram.y                      |  49 ++-
 src/backend/replication/logical/conflict.c     | 422 +++++++++++++++++++++++++
 src/bin/pg_dump/pg_dump.c                      |  96 +++++-
 src/bin/pg_dump/pg_dump.h                      | 118 ++++++-
 src/bin/psql/describe.c                        |  14 +-
 src/bin/psql/tab-complete.c                    |   6 +-
 src/include/catalog/Makefile                   |   3 +-
 src/include/catalog/meson.build                |   1 +
 src/include/catalog/pg_subscription_conflict.h |  55 ++++
 src/include/nodes/parsenodes.h                 |   6 +
 src/include/parser/kwlist.h                    |   1 +
 src/include/replication/conflict.h             |  51 +++
 src/test/regress/expected/oidjoins.out         |   1 +
 src/test/regress/expected/subscription.out     | 284 ++++++++++++-----
 src/test/regress/sql/subscription.sql          |  57 ++++
 src/tools/pgindent/typedefs.list               |   2 +
 21 files changed, 1369 insertions(+), 186 deletions(-)
 mode change 100644 => 100755 doc/src/sgml/ref/alter_subscription.sgml
 mode change 100644 => 100755 doc/src/sgml/ref/create_subscription.sgml
 create mode 100644 src/include/catalog/pg_subscription_conflict.h

diff --git a/doc/src/sgml/logical-replication.sgml b/doc/src/sgml/logical-replication.sgml
index df62eb4..f82adfc 100644
--- a/doc/src/sgml/logical-replication.sgml
+++ b/doc/src/sgml/logical-replication.sgml
@@ -1568,7 +1568,7 @@ test_sub=# SELECT * FROM t1 ORDER BY id;
  </sect1>
 
  <sect1 id="logical-replication-conflicts">
-  <title>Conflicts</title>
+  <title>Conflicts and conflict resolution</title>
 
   <para>
    Logical replication behaves similarly to normal DML operations in that
@@ -1582,83 +1582,15 @@ test_sub=# SELECT * FROM t1 ORDER BY id;
   </para>
 
   <para>
-   Additional logging is triggered, and the conflict statistics are collected (displayed in the
-   <link linkend="monitoring-pg-stat-subscription-stats"><structname>pg_stat_subscription_stats</structname></link> view)
-   in the following <firstterm>conflict</firstterm> cases:
-   <variablelist>
-    <varlistentry id="conflict-insert-exists" xreflabel="insert_exists">
-     <term><literal>insert_exists</literal></term>
-     <listitem>
-      <para>
-       Inserting a row that violates a <literal>NOT DEFERRABLE</literal>
-       unique constraint. Note that to log the origin and commit
-       timestamp details of the conflicting key,
-       <link linkend="guc-track-commit-timestamp"><varname>track_commit_timestamp</varname></link>
-       should be enabled on the subscriber. In this case, an error will be
-       raised until the conflict is resolved manually.
-      </para>
-     </listitem>
-    </varlistentry>
-    <varlistentry id="conflict-update-origin-differs" xreflabel="update_origin_differs">
-     <term><literal>update_origin_differs</literal></term>
-     <listitem>
-      <para>
-       Updating a row that was previously modified by another origin.
-       Note that this conflict can only be detected when
-       <link linkend="guc-track-commit-timestamp"><varname>track_commit_timestamp</varname></link>
-       is enabled on the subscriber. Currently, the update is always applied
-       regardless of the origin of the local row.
-      </para>
-     </listitem>
-    </varlistentry>
-    <varlistentry id="conflict-update-exists" xreflabel="update_exists">
-     <term><literal>update_exists</literal></term>
-     <listitem>
-      <para>
-       The updated value of a row violates a <literal>NOT DEFERRABLE</literal>
-       unique constraint. Note that to log the origin and commit
-       timestamp details of the conflicting key,
-       <link linkend="guc-track-commit-timestamp"><varname>track_commit_timestamp</varname></link>
-       should be enabled on the subscriber. In this case, an error will be
-       raised until the conflict is resolved manually. Note that when updating a
-       partitioned table, if the updated row value satisfies another partition
-       constraint resulting in the row being inserted into a new partition, the
-       <literal>insert_exists</literal> conflict may arise if the new row
-       violates a <literal>NOT DEFERRABLE</literal> unique constraint.
-      </para>
-     </listitem>
-    </varlistentry>
-    <varlistentry id="conflict-update-missing" xreflabel="update_missing">
-     <term><literal>update_missing</literal></term>
-     <listitem>
-      <para>
-       The tuple to be updated was not found. The update will simply be
-       skipped in this scenario.
-      </para>
-     </listitem>
-    </varlistentry>
-    <varlistentry id="conflict-delete-origin-differs" xreflabel="delete_origin_differs">
-     <term><literal>delete_origin_differs</literal></term>
-     <listitem>
-      <para>
-       Deleting a row that was previously modified by another origin. Note that
-       this conflict can only be detected when
-       <link linkend="guc-track-commit-timestamp"><varname>track_commit_timestamp</varname></link>
-       is enabled on the subscriber. Currently, the delete is always applied
-       regardless of the origin of the local row.
-      </para>
-     </listitem>
-    </varlistentry>
-    <varlistentry id="conflict-delete-missing" xreflabel="delete_missing">
-     <term><literal>delete_missing</literal></term>
-     <listitem>
-      <para>
-       The tuple to be deleted was not found. The delete will simply be
-       skipped in this scenario.
-      </para>
-     </listitem>
-    </varlistentry>
-   </variablelist>
+   Additional logging is triggered in various conflict scenarios, each identified as a
+   conflict type, and the conflict statistics are collected (displayed in the
+   <link linkend="monitoring-pg-stat-subscription-stats"><structname>pg_stat_subscription_stats</structname></link> view).
+   Users have the option to configure a <literal>conflict_resolver</literal> for each
+   <literal>conflict_type</literal> when creating a subscription.
+   For more information on the supported <literal>conflict_types</literal> detected and
+   <literal>conflict_resolvers</literal>, refer to section
+   <link linkend="sql-createsubscription-params-with-conflict-resolver"><literal>CONFLICT RESOLVERS</literal></link>.
+
     Note that there are other conflict scenarios, such as exclusion constraint
     violations. Currently, we do not provide additional details for them in the
     log.
diff --git a/doc/src/sgml/monitoring.sgml b/doc/src/sgml/monitoring.sgml
index 933de6f..6ead5c3 100644
--- a/doc/src/sgml/monitoring.sgml
+++ b/doc/src/sgml/monitoring.sgml
@@ -2181,7 +2181,7 @@ description | Waiting for a newly initialized WAL file to reach durable storage
       <para>
        Number of times a row insertion violated a
        <literal>NOT DEFERRABLE</literal> unique constraint during the
-       application of changes. See <xref linkend="conflict-insert-exists"/>
+       application of changes. See <xref linkend="sql-createsubscription-params-with-conflict_type-insert-exists"/>
        for details about this conflict.
       </para></entry>
      </row>
@@ -2193,7 +2193,7 @@ description | Waiting for a newly initialized WAL file to reach durable storage
       <para>
        Number of times an update was applied to a row that had been previously
        modified by another source during the application of changes. See
-       <xref linkend="conflict-update-origin-differs"/> for details about this
+       <xref linkend="sql-createsubscription-params-with-conflict_type-update-origin-differs"/> for details about this
        conflict.
       </para></entry>
      </row>
@@ -2205,7 +2205,7 @@ description | Waiting for a newly initialized WAL file to reach durable storage
       <para>
        Number of times that an updated row value violated a
        <literal>NOT DEFERRABLE</literal> unique constraint during the
-       application of changes. See <xref linkend="conflict-update-exists"/>
+       application of changes. See <xref linkend="sql-createsubscription-params-with-conflict_type-update-exists"/>
        for details about this conflict.
       </para></entry>
      </row>
@@ -2216,7 +2216,8 @@ description | Waiting for a newly initialized WAL file to reach durable storage
       </para>
       <para>
        Number of times the tuple to be updated was not found during the
-       application of changes. See <xref linkend="conflict-update-missing"/>
+       application of changes. See <xref linkend="sql-createsubscription-params-with-conflict_type-update-missing
+"/>
        for details about this conflict.
       </para></entry>
      </row>
@@ -2228,7 +2229,7 @@ description | Waiting for a newly initialized WAL file to reach durable storage
       <para>
        Number of times a delete operation was applied to row that had been
        previously modified by another source during the application of changes.
-       See <xref linkend="conflict-delete-origin-differs"/> for details about
+       See <xref linkend="sql-createsubscription-params-with-conflict_type-delete-origin-differs"/> for details about
        this conflict.
       </para></entry>
      </row>
@@ -2239,7 +2240,7 @@ description | Waiting for a newly initialized WAL file to reach durable storage
       </para>
       <para>
        Number of times the tuple to be deleted was not found during the application
-       of changes. See <xref linkend="conflict-delete-missing"/> for details
+       of changes. See <xref linkend="sql-createsubscription-params-with-conflict_type-delete-missing"/> for details
        about this conflict.
       </para></entry>
      </row>
diff --git a/doc/src/sgml/ref/alter_subscription.sgml b/doc/src/sgml/ref/alter_subscription.sgml
old mode 100644
new mode 100755
index fdc648d..e7b39f2
--- a/doc/src/sgml/ref/alter_subscription.sgml
+++ b/doc/src/sgml/ref/alter_subscription.sgml
@@ -32,6 +32,7 @@ ALTER SUBSCRIPTION <replaceable class="parameter">name</replaceable> SET ( <repl
 ALTER SUBSCRIPTION <replaceable class="parameter">name</replaceable> SKIP ( <replaceable class="parameter">skip_option</replaceable> = <replaceable class="parameter">value</replaceable> )
 ALTER SUBSCRIPTION <replaceable class="parameter">name</replaceable> OWNER TO { <replaceable>new_owner</replaceable> | CURRENT_ROLE | CURRENT_USER | SESSION_USER }
 ALTER SUBSCRIPTION <replaceable class="parameter">name</replaceable> RENAME TO <replaceable>new_name</replaceable>
+ALTER SUBSCRIPTION <replaceable class="parameter">name</replaceable> CONFLICT RESOLVER ( <replaceable class="parameter">conflict_type</replaceable> [= <replaceable class="parameter">conflict_resolver</replaceable>] [, ...] )
 </synopsis>
  </refsynopsisdiv>
 
@@ -345,6 +346,17 @@ ALTER SUBSCRIPTION <replaceable class="parameter">name</replaceable> RENAME TO <
      </para>
     </listitem>
    </varlistentry>
+
+   <varlistentry id="sql-altersubscription-params-conflict-resolver">
+    <term><literal>CONFLICT RESOLVER ( <replaceable class="parameter">conflict_type</replaceable> [= <replaceable class="parameter">conflict_resolver</replaceable>] [, ... ] )</literal></term>
+    <listitem>
+     <para>
+      This clause alters either the default conflict resolvers or those set by <xref linkend="sql-createsubscription"/>.
+      Refer to section <link linkend="sql-createsubscription-params-with-conflict-resolver"><literal>CONFLICT RESOLVERS</literal></link>
+      for the details on supported <literal>conflict_types</literal> and <literal>conflict_resolvers</literal>.
+     </para>
+    </listitem>
+   </varlistentry>
   </variablelist>
 
   <para>
diff --git a/doc/src/sgml/ref/create_subscription.sgml b/doc/src/sgml/ref/create_subscription.sgml
old mode 100644
new mode 100755
index 740b7d94..e04a269
--- a/doc/src/sgml/ref/create_subscription.sgml
+++ b/doc/src/sgml/ref/create_subscription.sgml
@@ -24,6 +24,7 @@ PostgreSQL documentation
 CREATE SUBSCRIPTION <replaceable class="parameter">subscription_name</replaceable>
     CONNECTION '<replaceable class="parameter">conninfo</replaceable>'
     PUBLICATION <replaceable class="parameter">publication_name</replaceable> [, ...]
+    [ CONFLICT RESOLVER ( <replaceable class="parameter">conflict_type</replaceable> [= <replaceable class="parameter">conflict_resolver</replaceable>] [, ...] ) ]
     [ WITH ( <replaceable class="parameter">subscription_parameter</replaceable> [= <replaceable class="parameter">value</replaceable>] [, ... ] ) ]
 </synopsis>
  </refsynopsisdiv>
@@ -432,6 +433,183 @@ CREATE SUBSCRIPTION <replaceable class="parameter">subscription_name</replaceabl
 
     </listitem>
    </varlistentry>
+
+   <varlistentry id="sql-createsubscription-params-with-conflict-resolver">
+    <term><literal>CONFLICT RESOLVER ( <replaceable class="parameter">conflict_type</replaceable> [= <replaceable class="parameter">conflict_resolver</replaceable>] [, ... ] )</literal></term>
+    <listitem>
+     <para>
+      This optional clause specifies options for conflict resolvers for different conflict_types.
+     </para>
+
+     <para>
+      The <replaceable class="parameter">conflict_type</replaceable> and their default behaviour are listed below.
+      <variablelist>
+       <varlistentry id="sql-createsubscription-params-with-conflict_type-insert-exists">
+        <term><literal>insert_exists</literal> (<type>enum</type>)</term>
+         <listitem>
+          <para>
+           This conflict occurs when inserting a row that violates a
+           <literal>NOT DEFERRABLE</literal> unique constraint.
+           To log the origin and commit timestamp details of the conflicting key,
+           <link linkend="guc-track-commit-timestamp"><varname>track_commit_timestamp</varname></link>
+           should be enabled on the subscriber. In this case, an error will be
+           raised until the conflict is resolved manually or the resolver is configured to a
+           non-default value that can automatically resolve the conflict.
+          </para>
+         </listitem>
+       </varlistentry>
+
+       <varlistentry id="sql-createsubscription-params-with-conflict_type-update-origin-differs">
+        <term><literal>update_origin_differs</literal> (<type>enum</type>)</term>
+         <listitem>
+          <para>
+           This conflict occurs when updating a row that was previously
+           modified by another origin.
+           Note that this conflict can only be detected when
+           <link linkend="guc-track-commit-timestamp"><varname>track_commit_timestamp</varname></link>
+           is enabled on the subscriber. Currently, the update is always applied
+           regardless of the origin of the local row.
+          </para>
+         </listitem>
+       </varlistentry>
+
+       <varlistentry id="sql-createsubscription-params-with-conflict_type-update-exists">
+        <term><literal>update_exists</literal> (<type>enum</type>)</term>
+         <listitem>
+          <para>
+           This conflict occurs when the updated value of a row violates
+           a <literal>NOT DEFERRABLE</literal>
+           unique constraint. To log the origin and commit
+           timestamp details of the conflicting key,
+           <link linkend="guc-track-commit-timestamp"><varname>track_commit_timestamp</varname></link>
+           should be enabled on the subscriber. In this case, an error will be
+           raised until the conflict is resolved manually or the resolver is configured to a
+           non-default value that can automatically resolve the conflict.
+           Note that when updating a partitioned table, if the updated row
+           value satisfies another partition constraint resulting in the
+           row being inserted into a new partition, the <literal>insert_exists</literal>
+           conflict may arise if the new row violates a <literal>NOT DEFERRABLE</literal>
+           unique constraint.
+          </para>
+         </listitem>
+       </varlistentry>
+
+      <varlistentry id="sql-createsubscription-params-with-conflict_type-update-missing">
+       <term><literal>update_missing</literal> (<type>enum</type>)</term>
+        <listitem>
+         <para>
+          This conflict occurs when the tuple to be updated was not found.
+          The update will simply be skipped in this scenario.
+         </para>
+        </listitem>
+       </varlistentry>
+
+       <varlistentry id="sql-createsubscription-params-with-conflict_type-delete-origin-differs">
+        <term><literal>delete_origin_differs</literal> (<type>enum</type>)</term>
+         <listitem>
+          <para>
+           This conflict occurs when deleting a row that was previously modified
+           by another origin. Note that this conflict can only be detected when
+           <link linkend="guc-track-commit-timestamp"><varname>track_commit_timestamp</varname></link>
+           is enabled on the subscriber. Currently, the delete is always applied
+           regardless of the origin of the local row.
+          </para>
+         </listitem>
+       </varlistentry>
+
+       <varlistentry id="sql-createsubscription-params-with-conflict_type-delete-missing">
+        <term><literal>delete_missing</literal> (<type>enum</type>)</term>
+         <listitem>
+          <para>
+           This conflict occurs when the tuple to be deleted was not found.
+           The delete will simply be skipped in this scenario.
+          </para>
+         </listitem>
+       </varlistentry>
+
+      </variablelist></para>
+
+     <para>
+      The <replaceable class="parameter">conflict_resolver</replaceable> and their behaviour
+      are listed below. Users can use any of the following resolvers for automatic conflict
+      resolution.
+      <variablelist>
+
+       <varlistentry id="sql-createsubscription-params-with-conflict_resolver-error">
+        <term><literal>error</literal> (<type>enum</type>)</term>
+         <listitem>
+          <para>
+           This resolver throws an error and stops replication. It can be used for
+           any conflict type.
+           It is the default resolver for <literal>insert_exists</literal> and
+           <literal>update_exists</literal>.
+          </para>
+         </listitem>
+       </varlistentry>
+
+       <varlistentry id="sql-createsubscription-params-with-conflict_resolver-skip">
+        <term><literal>skip</literal> (<type>enum</type>)</term>
+         <listitem>
+          <para>
+           This resolver skips processing the remote change and continue replication
+           with the next change.
+           It can be used for <literal>update_missing</literal> and
+           <literal>delete_missing</literal> and is the default resolver for these types.
+          </para>
+         </listitem>
+       </varlistentry>
+
+       <varlistentry id="sql-createsubscription-params-with-conflict_resolver-apply-remote">
+        <term><literal>apply_remote</literal> (<type>enum</type>)</term>
+         <listitem>
+          <para>
+           This resolver applies the remote change. It can be used for
+           <literal>insert_exists</literal>, <literal>update_exists</literal>,
+           <literal>update_origin_differs</literal> and <literal>delete_origin_differs</literal>.
+
+           It is the default resolver for <literal>insert_exists</literal> and
+           <literal>update_exists</literal>.
+          </para>
+         </listitem>
+       </varlistentry>
+
+       <varlistentry id="sql-createsubscription-params-with-conflict_resolver-keep-local">
+        <term><literal>keep_local</literal> (<type>enum</type>)</term>
+         <listitem>
+          <para>
+           With this resolver, the remote change is not applied and the local tuple is maintained.
+           It can be used for <literal>insert_exists</literal>, <literal>update_exists</literal>,
+           <literal>update_origin_differs</literal> and <literal>delete_origin_differs</literal>.
+          </para>
+         </listitem>
+       </varlistentry>
+
+       <varlistentry id="sql-createsubscription-params-with-conflict_resolver-apply-or-skip">
+        <term><literal>apply_or_skip</literal> (<type>enum</type>)</term>
+         <listitem>
+          <para>
+           This resolver is only used for <literal>update_missing</literal>.
+           An attempt is made to convert the update into an insert; if this
+           cannot be done due to missing information, then the change is skipped.
+          </para>
+         </listitem>
+       </varlistentry>
+
+       <varlistentry id="sql-createsubscription-params-with-conflict_resolver-apply-or-error">
+        <term><literal>apply_or_error</literal> (<type>enum</type>)</term>
+         <listitem>
+          <para>
+           This resolver is only used for <literal>update_missing</literal>.
+           An attempt is made to convert the update into an insert; if this cannot
+           be done due to missing information, then an error is thrown, and replication
+           is stopped.
+          </para>
+         </listitem>
+       </varlistentry>
+       </variablelist></para>
+
+     </listitem>
+    </varlistentry>
   </variablelist>
 
   <para>
diff --git a/src/backend/commands/subscriptioncmds.c b/src/backend/commands/subscriptioncmds.c
index 02ccc63..131e4f5 100644
--- a/src/backend/commands/subscriptioncmds.c
+++ b/src/backend/commands/subscriptioncmds.c
@@ -14,6 +14,7 @@
 
 #include "postgres.h"
 
+#include "access/commit_ts.h"
 #include "access/htup_details.h"
 #include "access/table.h"
 #include "access/twophase.h"
@@ -28,6 +29,7 @@
 #include "catalog/pg_database_d.h"
 #include "catalog/pg_subscription.h"
 #include "catalog/pg_subscription_rel.h"
+#include "catalog/pg_subscription_conflict.h"
 #include "catalog/pg_type.h"
 #include "commands/dbcommands.h"
 #include "commands/defrem.h"
@@ -36,7 +38,9 @@
 #include "executor/executor.h"
 #include "miscadmin.h"
 #include "nodes/makefuncs.h"
+#include "parser/scansup.h"
 #include "pgstat.h"
+#include "replication/conflict.h"
 #include "replication/logicallauncher.h"
 #include "replication/logicalworker.h"
 #include "replication/origin.h"
@@ -440,6 +444,50 @@ parse_subscription_options(ParseState *pstate, List *stmt_options,
 }
 
 /*
+ * Parsing function for conflict resolvers in CREATE SUBSCRIPTION command.
+ * This function will report an error if mutually exclusive or duplicate
+ * options are specified.
+ */
+static void
+parse_subscription_conflict_resolvers(List *stmtresolvers,
+									  ConflictTypeResolver *resolvers)
+{
+	ListCell   *lc;
+	List	   *SeenTypes = NIL;
+
+	/* Warn users if prerequisites are not met. */
+	if (stmtresolvers)
+		conf_detection_check_prerequisites();
+
+	/* First initialize the resolvers with default values. */
+	SetDefaultResolvers(resolvers);
+
+	foreach(lc, stmtresolvers)
+	{
+		DefElem    *defel = (DefElem *) lfirst(lc);
+		ConflictType type;
+		char	   *resolver;
+
+		/* Check if the conflict type already exists in the list */
+		if (list_member(SeenTypes, makeString(defel->defname)))
+			ereport(ERROR,
+					(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
+					 errmsg("duplicate conflict type \"%s\" found", defel->defname)));
+
+		/* Validate the conflict type and resolver. */
+		resolver = defGetString(defel);
+		type = validate_conflict_type_and_resolver(defel->defname,
+												   defGetString(defel));
+
+		/* Add the conflict type to the list of seen types */
+		SeenTypes = lappend(SeenTypes, makeString((char *)resolvers[type].conflict_type));
+
+		/* Update the corresponding resolver for the given conflict type. */
+		resolvers[type].resolver = downcase_truncate_identifier(resolver, strlen(resolver), false);
+	}
+}
+
+/*
  * Add publication names from the list to a string.
  */
 static void
@@ -583,6 +631,7 @@ CreateSubscription(ParseState *pstate, CreateSubscriptionStmt *stmt,
 	bits32		supported_opts;
 	SubOpts		opts = {0};
 	AclResult	aclresult;
+	ConflictTypeResolver conflictResolvers[CT_MAX + 1];
 
 	/*
 	 * Parse and check options.
@@ -597,6 +646,9 @@ CreateSubscription(ParseState *pstate, CreateSubscriptionStmt *stmt,
 					  SUBOPT_RUN_AS_OWNER | SUBOPT_FAILOVER | SUBOPT_ORIGIN);
 	parse_subscription_options(pstate, stmt->options, supported_opts, &opts);
 
+	/* Parse and check conflict resolvers. */
+	parse_subscription_conflict_resolvers(stmt->resolvers, conflictResolvers);
+
 	/*
 	 * Since creating a replication slot is not transactional, rolling back
 	 * the transaction leaves the created replication slot.  So we cannot run
@@ -723,6 +775,9 @@ CreateSubscription(ParseState *pstate, CreateSubscriptionStmt *stmt,
 
 	recordDependencyOnOwner(SubscriptionRelationId, subid, owner);
 
+	/* Update the Conflict Resolvers in pg_subscription_conflict */
+	SetSubConflictResolver(subid, conflictResolvers, CT_MAX + 1);
+
 	ReplicationOriginNameForLogicalRep(subid, InvalidOid, originname, sizeof(originname));
 	replorigin_create(originname);
 
@@ -1581,6 +1636,46 @@ AlterSubscription(ParseState *pstate, AlterSubscriptionStmt *stmt,
 				update_tuple = true;
 				break;
 			}
+		case ALTER_SUBSCRIPTION_CONFLICT_RESOLVERS:
+			{
+				List	   *conflict_resolvers = NIL;
+
+				conf_detection_check_prerequisites();
+
+				/* Get the list of conflict types and resolvers and validate them. */
+				conflict_resolvers = GetAndValidateSubsConflictResolverList(stmt->resolvers);
+
+				/*
+				 * Update the conflict resolvers for the corresponding
+				 * conflict types in the pg_subscription_conflict catalog.
+				 */
+				UpdateSubConflictResolvers(conflict_resolvers, subid);
+				break;
+			}
+		case ALTER_SUBSCRIPTION_RESET_ALL_CONFLICT_RESOLVERS:
+			{
+				ConflictTypeResolver conflictResolvers[CT_MAX + 1];
+
+				/* Remove the existing conflict resolvers. */
+				RemoveSubscriptionConflictResolvers(subid);
+
+				/*
+				 * Create list of conflict resolvers and set them in the
+				 * catalog.
+				 */
+				SetDefaultResolvers(conflictResolvers);
+				SetSubConflictResolver(subid, conflictResolvers, CT_MAX + 1);
+				break;
+			}
+		case ALTER_SUBSCRIPTION_RESET_CONFLICT_RESOLVER:
+			{
+				/*
+				 * Reset the conflict resolver for this conflict type to its
+				 * default.
+				 */
+				ResetConflictResolver(subid, stmt->conflict_type);
+				break;
+			}
 
 		default:
 			elog(ERROR, "unrecognized ALTER SUBSCRIPTION kind %d",
@@ -1832,6 +1927,9 @@ DropSubscription(DropSubscriptionStmt *stmt, bool isTopLevel)
 	/* Remove any associated relation synchronization states. */
 	RemoveSubscriptionRel(subid, InvalidOid);
 
+	/* Remove any associated conflict resolvers */
+	RemoveSubscriptionConflictResolvers(subid);
+
 	/* Remove the origin tracking if exists. */
 	ReplicationOriginNameForLogicalRep(subid, InvalidOid, originname, sizeof(originname));
 	replorigin_drop_by_name(originname, true, false);
diff --git a/src/backend/parser/gram.y b/src/backend/parser/gram.y
index 84cef57..3c090b0 100644
--- a/src/backend/parser/gram.y
+++ b/src/backend/parser/gram.y
@@ -425,7 +425,7 @@ static Node *makeRecursiveViewSelect(char *relname, List *aliases, Node *query);
 				OptTableElementList TableElementList OptInherit definition
 				OptTypedTableElementList TypedTableElementList
 				reloptions opt_reloptions
-				OptWith opt_definition func_args func_args_list
+				OptWith opt_definition opt_resolver_definition func_args func_args_list
 				func_args_with_defaults func_args_with_defaults_list
 				aggr_args aggr_args_list
 				func_as createfunc_opt_list opt_createfunc_opt_list alterfunc_opt_list
@@ -612,6 +612,7 @@ static Node *makeRecursiveViewSelect(char *relname, List *aliases, Node *query);
 %type <ival>	opt_check_option
 
 %type <str>		opt_provider security_label
+%type <str>		conflict_type
 
 %type <target>	xml_attribute_el
 %type <list>	xml_attribute_list xml_attributes
@@ -769,7 +770,7 @@ static Node *makeRecursiveViewSelect(char *relname, List *aliases, Node *query);
 
 	RANGE READ REAL REASSIGN RECURSIVE REF_P REFERENCES REFERENCING
 	REFRESH REINDEX RELATIVE_P RELEASE RENAME REPEATABLE REPLACE REPLICA
-	RESET RESTART RESTRICT RETURN RETURNING RETURNS REVOKE RIGHT ROLE ROLLBACK ROLLUP
+	RESET RESOLVER RESTART RESTRICT RETURN RETURNING RETURNS REVOKE RIGHT ROLE ROLLBACK ROLLUP
 	ROUTINE ROUTINES ROW ROWS RULE
 
 	SAVEPOINT SCALAR SCHEMA SCHEMAS SCROLL SEARCH SECOND_P SECURITY SELECT
@@ -8754,6 +8755,11 @@ opt_definition:
 			| /*EMPTY*/								{ $$ = NIL; }
 		;
 
+opt_resolver_definition:
+			CONFLICT RESOLVER definition			{ $$ = $3; }
+			| /*EMPTY*/								{ $$ = NIL; }
+		;
+
 table_func_column:	param_name func_type
 				{
 					FunctionParameter *n = makeNode(FunctionParameter);
@@ -10688,14 +10694,15 @@ AlterPublicationStmt:
  *****************************************************************************/
 
 CreateSubscriptionStmt:
-			CREATE SUBSCRIPTION name CONNECTION Sconst PUBLICATION name_list opt_definition
+	CREATE SUBSCRIPTION name CONNECTION Sconst PUBLICATION name_list opt_resolver_definition opt_definition
 				{
 					CreateSubscriptionStmt *n =
 						makeNode(CreateSubscriptionStmt);
 					n->subname = $3;
 					n->conninfo = $5;
 					n->publication = $7;
-					n->options = $8;
+					n->resolvers = $8;
+					n->options = $9;
 					$$ = (Node *) n;
 				}
 		;
@@ -10802,6 +10809,38 @@ AlterSubscriptionStmt:
 					n->options = $5;
 					$$ = (Node *) n;
 				}
+			| ALTER SUBSCRIPTION name opt_resolver_definition
+				{
+					AlterSubscriptionStmt *n =
+						makeNode(AlterSubscriptionStmt);
+
+					n->kind = ALTER_SUBSCRIPTION_CONFLICT_RESOLVERS;
+					n->subname = $3;
+					n->resolvers = $4;
+					$$ = (Node *) n;
+				}
+			| ALTER SUBSCRIPTION name RESET CONFLICT RESOLVER ALL
+				{
+					AlterSubscriptionStmt *n =
+						makeNode(AlterSubscriptionStmt);
+
+					n->kind = ALTER_SUBSCRIPTION_RESET_ALL_CONFLICT_RESOLVERS;
+					n->subname = $3;
+					$$ = (Node *) n;
+				}
+			| ALTER SUBSCRIPTION name RESET CONFLICT RESOLVER FOR conflict_type
+				{
+					AlterSubscriptionStmt *n =
+						makeNode(AlterSubscriptionStmt);
+
+					n->kind = ALTER_SUBSCRIPTION_RESET_CONFLICT_RESOLVER;
+					n->subname = $3;
+					n->conflict_type = $8;
+					$$ = (Node *) n;
+				}
+		;
+conflict_type:
+			Sconst								{ $$ = $1; }
 		;
 
 /*****************************************************************************
@@ -17725,6 +17764,7 @@ unreserved_keyword:
 			| REPLACE
 			| REPLICA
 			| RESET
+			| RESOLVER
 			| RESTART
 			| RESTRICT
 			| RETURN
@@ -18353,6 +18393,7 @@ bare_label_keyword:
 			| REPLACE
 			| REPLICA
 			| RESET
+			| RESOLVER
 			| RESTART
 			| RESTRICT
 			| RETURN
